/* bmp2dir.c --> converts a 24 bit bmp image to a dir image

This is bmp2dir v0.0a by Abraham Macas Paredes.

This source code is Copyright 2004 Abraham Macas Paredes.  It is distributed
under the terms of the GNU General Public License, version 2 or later.
You should have received a copy of the GPL along with this source code;
if not, see http://www.gnu.org/copyleft/gpl.html.

I have tested this code only under gcc and Linux Debian v7.0r0.

If you find this source code useful or you have problems, please let
me know!  My email address is amp_21004@yahoo.es


*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fcntl.h>

#define WORD short
#define DWORD long
#define sign(a) (((a)>0)?1:-1)

//#define DEBUG 3

typedef struct
{
 WORD bfType;
 DWORD bfSize;
 WORD bfReserved1;
 WORD bfReserved2;
 DWORD bfOffBits;
} BitmapFileHeader;

typedef struct
{
 DWORD biSize;
 DWORD biWidth;
 DWORD biHeight;
 WORD biPlanes;
 WORD biBitCount;
 DWORD biCompresion;
 DWORD biSizeImage;
 DWORD biXPelsPerMeter;
 DWORD biYPelsPerMeter;
 DWORD biClrUsed;
 DWORD biClrImportant;
} BitmapInfoHeader;

/*================================================================================*/
int **Sections=NULL;
int nsections=0;
unsigned Actual[16][16];
unsigned *Past;

/*================================================================================*/
void sub_filter(unsigned char *src, unsigned char *dst, int len)
{
 int i,l;
 l=len-3;

 for(i=0;i<l;i++)
 {
  *dst=*src - *(src+3);
  dst++;
  src++;
 }/*for*/

 for(i=0;i<3;i++)
 {
  *dst=*src;
  dst++;
  src++;
 }/*for*/


}/*sub_filter*/
/*================================================================================*/
void sub_filter_inv(unsigned char *src, unsigned char *dst, int len)
{
 int i,l;
 l=len-3;
 dst=dst+len-1;
 src=src+len-1;

 for(i=0;i<3;i++)
 {
  *dst=*src;
  dst--;
  src--;
 }/*for*/

 for(i=0;i<l;i++)
 {
  *dst=*src + *(dst+3);
  dst--;
  src--;
 }/*for*/



}/*sub_filter*/
/*================================================================================*/
/* EQUALITY FUNCTION */
int Equals(int *One, int *Two)
{
 int e=1;
 int x;

 for(x=0;x<256;x++)
  if(One[x]!=Two[x])
   e=0;

 return e;
}/*Equals*/



/*================================================================================*/
void bubble(unsigned char *Numbers, int Begin, int End)
{
 int pos,ele,aux;

 for(pos=Begin;pos<End;pos++)
  for(ele=End;ele>pos;ele--)
   if(Numbers[ele]<Numbers[ele-1])
   {
    aux=Numbers[ele];
    Numbers[ele]=Numbers[ele-1];
    Numbers[ele-1]=aux;
   }/*if*/
}/*bubble*/

/*================================================================================*/
/* Basic compression function of one 16x16 block that can be compressed */
/* The source 16x16 block is in Actual variable*/
int Direccional(unsigned char *dst)
{
 int x,y,x2,y2,n,m,Col;
 unsigned char *dest, *number;
 dest=dst;


    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
     {
      if(Actual[x][y]!=0)
      {
       *dest=(Actual[x][y]>>16) & 0xFF;
       dest++;
       *dest=(Actual[x][y]>>8) & 0xFF;
       dest++;
       *dest=Actual[x][y] & 0xFF;
       dest++;
       *dest=1;
       number=dest;
       dest++;
       *dest= (x << 4) | y;
       dest++;
       Col=Actual[x][y];
       Actual[x][y]=0;
       for(y2=0;y2<16;y2++)
        for(x2=0;x2<16;x2++)
         if(Col==Actual[x2][y2])
         {
          *dest= x2 << 4 | y2;
          dest++;
          Actual[x2][y2]=0;
          *number=*number+1;
         }/*if*/

       if(*number==0)
       {
        /* If 256 colors */
        dest=number+1;
       }/*if*/
       else
       if(*number>=224)
       {
        int n,m;
        unsigned char *source;


        source=number+1;
        bubble(source,0,*number-1);

        m=*source;
        for(n=0;n<*source;n++)
        {
         *dest=(char) n;
         dest++;
        }/*for*/
        source++;

        for(n=m+1;n<256;n++)
         if(n!=*source)
         {
          *dest=(char) n;
          dest++;
         }/*if*/
         else
         {
          source++;
         }/*else*/

        source=dest-256+(*number);
        dest=number+1;
        for(n=0;n<256-*number;n++)
        {
         *dest=*source;
         dest++;
         source++;
        }/*for*/
        
       }/*if*/
       else
       if(*number>32)
       {
        /* Set the bitmap*/
        int n,m,num;
        unsigned char *source;


        source=number+1;
        bubble(source,0,*number-1);
        for(n=0;n<32;n++)
         *(dest+n)=0;

        m=0;
        num=*number;

        for(n=0;n<256;n++)
         if(n==*source)
         {
          source++;
          (*dest)<<=1;
          (*dest)|=1;
          num--;
          if(num==0)
           source--;
          m++;
          if(m==8)
          {
           dest++;
           m=0;
          }/*if*/
         }/*if*/
         else
         {
          *dest<<=1;
          *dest|=0;
          m++;
          if(m==8)
          {
           dest++;
           m=0;
          }/*if*/
         }/*else*/
        if(num!=0)
         printf("Error codifing %i positons: Error: %i\n", *number, num);

        source=dest-32;
        dest=number+1;

        for(n=0;n<32;n++)
        {
         *dest=*source;
         dest++;
         source++;
        }/*for*/
       }/*if*/
      }/*if*/
     }/*for*/



 return dest-dst;
}/*Direccional*/
/*================================================================================*/
/* Basic decompression function of one 16x16 block that can be compressed */
/* The dest 16x16 block is in Past variable and must be allocated*/
int DireccionalInv(unsigned char *src)
{
 int x,y,x2,y2,n,m,k,Total;
 unsigned Colour;
 unsigned number;
 unsigned char *sour;

 sour=src;
 Total=256; /* 256 colours */

    /* Fill with zeroes */
    for(x=0;x<16;x++)
     for(y=0;y<16;y++)
      Past[x + (y<<4)]=0;

   /* Take one section */
   Colour=*src;
   Colour<<=8;
   src++;
   Colour|=*src;
   Colour<<=8;
   src++;
   Colour|=*src;
   src++;
   number=*src;
   src++;


    /* Fill with colour*/
    if(number==0x00)
    {
     /* Fill the 256 elements with colour */
     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
       Past[x + (y<<4)]=Colour;
     Colour=0;
     src++;
     Total=0;
    }/*if*/
    else
    if(number==0xFF)
    {
     /* Fill the 255 elements with colour */
     int n;
     n=*src;

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
       if((x + (y<<4)) != n)
        Past[x + (y<<4)]=Colour;

     src++;
     Colour=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     src++;
     number=*src;
     src++;

     Total=0;
    }/*if*/


    while(Colour!=0 && Total>0)
    {
     if(number<=32)
     {
      for(k=0;k<number;k++)
      {
       x=*src;
       y=x & 0xF;
       x=x>>4;
       Past[x + (y<<4)]=Colour;
       src++;
      }/*for*/
      Total-=number;
     }/*if*/
     else
     if(number<224)
     {
      /* get the bitmap*/
      int n,m,num;
      unsigned char *source;
      m=0;
      num=number;


      for(k=0;k<256;k++)
      {
       if( (*src) & 0x80 )
       {
        x=k;
        y=x & 0xF;
        x=x>>4;
        Past[x + (y<<4)]=Colour;
        num--;
       }/*if*/
       (*src)<<=1;
       m++;
       if(m==8)
       {
        m=0;
        src++;
       }/*if*/
      }/*for*/

      if(num!=0)
       printf("Error in the codification of the bitmap. Error: %i\n", num);

      Total-=number;
     }/*if*/
     else
     {
      int n,m;
      unsigned char *dest;

      dest=src;

      for(n=0;n<256;n++)
       if(n!=*src)
       {
        x=n;
        y=x & 0xF;
        x=x>>4;
        Past[x + (y<<4)]=Colour;
       }
       else
       if(src-dest<256-number-1)
       {
        src++;
       }
      src++;

      Total-=number;
     }/*else*/

     Colour=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     Colour<<=8;
     src++;
     Colour|=*src;
     src++;
     number=*src;
     src++;
    }/*while*/


 return src-sour;
}/*DireccionalInv*/
/*================================================================================*/
/* COMPRESSION FUNCTION */
int Compress(unsigned char *src, unsigned char *dst, int width, int height)
{
 int Colour;
 int i,j,w,h;
 unsigned k;
 int x,y,x2,y2,n,m;
 int len;
 unsigned char *dest, *number, *prev;
 char founded=0;
 char zeroes=0;
 char eos=1; /* End Of Section*/
 unsigned char *Section[8];
 unsigned char *Pointers[8];
#if DEBUG == 1
 int CBS[9]; /* Number of sections compressed by each method*/
#endif
 int Colours[256];
 int NCol[256];
 int ncolours=0;

 /* Initializes some variables */
#if DEBUG == 1
 for(i=0;i<9;i++)
  CBS[i]=0;
#endif

 len=0;
 nsections=0;
 dest=dst;
 w=width/16;
 if(w*16!=width)
  w++;
 h=height/16;
 if(h*16!=height)
  h++;

#if DEBUG == 1
printf("Allocating resources\n");
#endif
 /* Allocate Sections array */
 if((Sections=malloc(w*h*sizeof(int *))) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/
 for(i=0;i<w*h;i++)
  Sections[i]=NULL;

 /* Allocate Section 0 array, code=1, 256 elements = X*/
 if((Section[0]=malloc(w*h*3)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 1 array, code=2, 255 elements = X*/
 if((Section[1]=malloc(w*h*7)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 2 array, code=3, equal to a previous section*/
 if((Section[2]=malloc(w*h*2)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 3 array, code=4, Codification with color elimination*/
 if((Section[3]=malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 4 array, code=5, Codification with 0 color*/
 if((Section[4]=malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 5 array, code=6, Codification without 0 color*/
 if((Section[5]=malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 6 array, code=7, RAW data*/
 if((Section[6]=malloc(w*h*768)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/

 /* Allocate Section 7 array, code=8, 2 colours*/
 if((Section[7]=malloc(w*h*38)) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/


 for(i=0;i<8;i++)
  Pointers[i]=Section[i];

#if DEBUG == 1
printf("Start Compression\n");
#endif

 /* Make the compression */
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   /* Take one section */
#if DEBUG == 2
printf("Take section (%i,%i)\n",j,i);
#endif
    /* Allocate memory */
   if((Past=(int *)malloc(256*sizeof(int))) == NULL)
   {
    perror("Error allocating memory for one section\n");
    exit(1);
   }/*if*/
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
    {
     if( ((j*16+x)<width) && ((i*16+y)<height) )
     {
      Past[x + (y<<4)]=src[(j*16+x)*3 + (i*16+y)*width*3];
      Past[x + (y<<4)]<<=8;
      Past[x + (y<<4)]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 1];
      Past[x + (y<<4)]<<=8;
      Past[x + (y<<4)]|=src[(j*16+x)*3 + (i*16+y)*width*3 + 2];
     }
     else
      Past[x + (y<<4)]=0;
    }/*for*/
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
     Actual[x][y]=Past[x + (y<<4)];

#if DEBUG == 3
printf("One section taken (%i,%i)\n",j,i);
printf("Section:\n");
for(y=0;y<16;y++)
printf(" %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x\n",
Actual[0][y],
Actual[1][y],
Actual[2][y],
Actual[3][y],
Actual[4][y],
Actual[5][y],
Actual[6][y],
Actual[7][y],
Actual[8][y],
Actual[9][y],
Actual[10][y],
Actual[11][y],
Actual[12][y],
Actual[13][y],
Actual[14][y],
Actual[15][y]);

#endif

    /* Compare with zero */
    zeroes=1;
    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
      zeroes&=(Actual[x][y]==0);

    if(zeroes)
    {
      /*There is 256 zeroes!*/
      *dest=0x00; /*Put the code */
      dest++;
      Sections[nsections++]=Past;
#if DEBUG == 1
      CBS[0]++;
#endif
#if DEBUG == 2
 printf("Zeroes section\n");
#endif
    }/*if*/
    else
    {
     /* Compare with anothers secctions */
     founded=0;
     if(nsections>0)
     {
      for(k=0;k<nsections && !founded;k++)
       if(Sections[k]!=NULL)
       {
        if(Equals(Past,Sections[k]))
        {
         *dest=0x03; /*Put the code */
         dest++;
#if DEBUG == 1
         CBS[3]++;
#endif
         *Pointers[2]=((k+1)>>8) & 0xFF;
         Pointers[2]++;
         *Pointers[2]=(k+1) & 0xFF;
         Pointers[2]++;
         Sections[nsections]=NULL;
         nsections++;
         founded=1;
         free(Past);
        }/*if*/
       }/*if*/
     }/*if*/
    }/*else*/


#if DEBUG == 2
if(founded)
 printf("Section (%i,%i) founded!\n",j,i);
else
 printf("Section (%i,%i) not founded!\n",j,i);
#endif

   /* If not founded */
   if(!founded && !zeroes)
   {
    /* Put the Section*/
    Sections[nsections++]=Past;

    /* Make a histogram */
    ncolours=0;
    for(y=0;y<256;y++)
    {
     Colours[y]=0;
     NCol[y]=0;
    }/*for*/

    for(y=0;y<16;y++)
     for(x=0;x<16;x++)
      if(ncolours>0)
      {
       m=0;
       for(n=0;n<ncolours;n++)
        if(Actual[x][y]==Colours[n])
        {
         m=1;
         NCol[n]++;
        }/*if*/
       if(!m)
       {
        Colours[ncolours]=Actual[x][y];
        NCol[ncolours]=1;
        ncolours++;
       }/*if*/
      }/*if*/
      else
      {
       ncolours=1;
       Colours[0]=Actual[x][y];
       NCol[0]=1;
      }/*else*/

#if DEBUG == 3
printf("Histogram:\n");
for(n=0;n<ncolours;n++)
 printf("Colour=%2x N= %i\n",Colours[n],NCol[n]);
#endif


    if(ncolours==1)
    {
     m=0;

     if((NCol[m]==256) && (Colours[m]==0))
      printf("Extrange error, previously undetected zero section\n");

     if((NCol[m]==256) && (Colours[m]!=0))
     {
      /*There is 256 colours*/
      *dest=0x01; /*Put the code */
      dest++;
#if DEBUG == 1
      CBS[1]++;
#endif      
      /*Put the colour in the 0 section */
      *Pointers[0]=(Colours[m]>>16) & 0xFF;
      Pointers[0]++;
      *Pointers[0]=(Colours[m]>>8) & 0xFF;
      Pointers[0]++;
      *Pointers[0]=Colours[m] & 0xFF;
      Pointers[0]++;
#if DEBUG == 2
  printf("256 Colours\n");
#endif
     }/*if*/
    }/*if*/

    if(ncolours==2)
    {
     m=0;
     for(n=0;n<ncolours;n++)
      if(NCol[n]==255)
      {
       m=n;
       break;
      }/*if*/

     if(NCol[m]==255)
     {
      /*There is 255 colours*/
      *dest=0x02; /*Put the code */
      dest++;
#if DEBUG == 1
      CBS[2]++;
#endif      
      /*Put the main colour in the 1 section */
      *Pointers[1]=(Colours[m]>>16) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=(Colours[m]>>8) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=Colours[m] & 0xFF;
      Pointers[1]++;
      /*Put the secondary colour in the 1 section */
      m=(m + 1) & 1;
      *Pointers[1]=(Colours[m]>>16) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=(Colours[m]>>8) & 0xFF;
      Pointers[1]++;
      *Pointers[1]=Colours[m] & 0xFF;
      Pointers[1]++;
      /* Put the address of the secondary colour*/
      for(y=0;y<16;y++)
       for(x=0;x<16;x++)
        if(Actual[x][y]==Colours[m])
        {
         *Pointers[1]= (x << 4) | y;
         Pointers[1]++;
         break;
        }/*if*/

#if DEBUG == 2
  printf("255 Colours\n");
#endif
     }/*if*/
     else
     {
      /*There is 2 colours*/
      *dest=0x08; /*Put the code */
      dest++;
#if DEBUG == 1
      CBS[8]++;
#endif      
      /*Put the main colour in the 1 section */
      *Pointers[7]=(Colours[0]>>16) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=(Colours[0]>>8) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=Colours[0] & 0xFF;
      Pointers[7]++;
      /*Put the secondary colour in the 1 section */
      *Pointers[7]=(Colours[1]>>16) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=(Colours[1]>>8) & 0xFF;
      Pointers[7]++;
      *Pointers[7]=Colours[1] & 0xFF;
      Pointers[7]++;

      /* Put the bitmap*/
      n=0;

      for(y=0;y<16;y++)
       for(x=0;x<16;x++)
       {
        *Pointers[7]<<=1;
        *Pointers[7]|=(Actual[x][y]==Colours[0]);
        n++;
        if(n==8)
        {
         Pointers[7]++;
         n=0;
        }/*if*/
       }/*for*/

#if DEBUG == 2
  printf("2 Colours\n");
#endif

     }/*else*/

    }/*if*/

    if(ncolours>127)
    {
     /* Can not compress so it is a raw section */
     *dest=0x07; /*Put the code */
     dest++;
#if DEBUG == 1
     CBS[7]++;
#endif     
     /* Put the information */
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       *Pointers[6]=(Actual[x][y]>>16) & 0xFF;
       Pointers[6]++;
       *Pointers[6]=(Actual[x][y]>>8) & 0xFF;
       Pointers[6]++;
       *Pointers[6]=Actual[x][y] & 0xFF;
       Pointers[6]++;
      }/*for*/
#if DEBUG == 2
  printf("RAW Section\n");
#endif
    }/*if*/

    if(ncolours>2 && ncolours<128)
    {
     /*Compress*/
     int Zero;
     m=0;

     for(n=0;n<ncolours;n++)
      if((NCol[n]>32) && (Colours[n]!=0))
       m++;

     Zero=0;
     for(n=0;n<ncolours;n++)
      if(Colours[n]==0)
       Zero=1;

     if(m>1 && !Zero)
     {
      /* There is 2 colours with more than 32 elements, so we eliminate a colour*/
      int A,B,C,Z,AxorB;
      A=0;
      for(n=0;n<ncolours;n++)
       if((NCol[n]>32))
       {
        A=n;
        break;
       }/*if*/
      B=0;
      for(n=0;n<ncolours;n++)
       if((NCol[n]>32) && (n!=A))
       {
        B=n;
        break;
       }/*if*/
      C=0;
      for(n=0;n<ncolours;n++)
       if((n!=A)&& (n!=B))
       {
        C=n;
        break;
       }/*if*/

      /*We have A,B,C selected*/
      Z=Colours[A]^Colours[B]^Colours[C];
      /*
       Pass 1:
        A^Z=B^C
        B^Z=A^C
        C^Z=A^B
        X^Z=X^Z

      */

     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       Actual[x][y]^=Z;


     AxorB=Colours[A]^Colours[B];
     /*
      Pass 2:
       A^C^AxorB=B^C
       A^B^AxorB=0
     */
     *dest=0x04; /*Put the code */
     dest++;
#if DEBUG == 1
     CBS[4]++;
#endif     
     /* Put A*/
     *Pointers[3]=(Colours[A]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[A]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[A] & 0xFF;
     Pointers[3]++;
     /* Put B*/
     *Pointers[3]=(Colours[B]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[B]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[B] & 0xFF;
     Pointers[3]++;
     /* Put C*/
     *Pointers[3]=(Colours[C]>>16) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=(Colours[C]>>8) & 0xFF;
     Pointers[3]++;
     *Pointers[3]=Colours[C] & 0xFF;
     Pointers[3]++;

     /* Put the Bitmap */
     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       if((Actual[x][y]==(Colours[A]^Colours[C])) || (Actual[x][y]==(Colours[A]^Colours[B])))
       {
        (*Pointers[3])<<=1;
        (*Pointers[3])|=1;
        Actual[x][y]^=AxorB;
        n++;
        if(n==8)
        {
         n=0;
         Pointers[3]++;
        }/*if*/
       }/*if*/
       else
       {
        (*Pointers[3])<<=1;
        n++;
        if(n==8)
        {
         n=0;
         Pointers[3]++;
        }/*if*/
       }/*else*/

      /* Put the normal directional compression */
      Z=Direccional(Pointers[3]);


      Pointers[3]+=Z;
      /*Put the End Of Section Symbol*/
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;
      *Pointers[3]=0x00;
      Pointers[3]++;

#if DEBUG == 2
  printf("With elimination\n");
#endif

     }/*if*/
     else
     if(Zero)
     {
      /* Normal compression with zero*/
      *dest=0x05; /*Put the code */
      dest++;
#if DEBUG == 1
      CBS[5]++;
#endif
      /* Put the normal directional compression */
      n=Direccional(Pointers[4]);
      Pointers[4]+=n;
      /*Put the End Of Section Symbol*/
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;
      *Pointers[4]=0x00;
      Pointers[4]++;
#if DEBUG == 2
  printf("With zero\n");
#endif

     }/*if*/
     else
     {
      /* Normal compression without zero*/
      *dest=0x06; /*Put the code */
      dest++;
#if DEBUG == 1
      CBS[6]++;
#endif
      /* Put the normal directional compression */
      n=Direccional(Pointers[5]);
      Pointers[5]+=n;
#if DEBUG == 2
  printf("Without zero\n");
#endif

     }/*else*/


    }/*if*/


   }/*if*/
  }/*for*/

#if DEBUG == 1
printf("Putting the diferents buffer into the dest buffer\n");
#endif
  /* Put the sizes */
  for(i=0;i<7;i++)
  {
   *dest=((Pointers[i]-Section[i])>>24) & 0xFF;
   dest++;
   *dest=((Pointers[i]-Section[i])>>16) & 0xFF;
   dest++;
   *dest=((Pointers[i]-Section[i])>>8) & 0xFF;
   dest++;
   *dest=(Pointers[i]-Section[i]) & 0xFF;
   dest++;
  }/*for*/

#if DEBUG == 2
printf("Sizes=\n");
  for(i=0;i<8;i++)
  {
   printf("Size[%i]=%i\n",i,(Pointers[i]-Section[i]));
   for(j=0;j<10;j++)
    printf("%2x ", *(Section[i]+j));
   printf("\n");
  }
#endif


  /* Put the content of each section */
  for(i=0;i<8;i++)
  {
   memcpy(dest,Section[i],Pointers[i]-Section[i]);
   dest+=Pointers[i]-Section[i];
  }/*for*/

  len=dest-dst;


#if DEBUG == 1
printf("Deallocating resources\n");
#endif
 for(i=0;i<w*h;i++)
  if(Sections[i]!=NULL)
   free(Sections[i]);

 free(Sections);
 for(i=0;i<8;i++)
  free(Section[0]);

#if DEBUG == 1
 printf("There is %i sections\n",w*h);
 for(i=0;i<9;i++)
  printf("CBS[%i]=%i\n",i,CBS[i]);
#endif

 return len;
}/*Compress*/

/*================================================================================*/
/* DECOMPRESSION FUNCTION */
void Decompress(unsigned char *src,unsigned char *dst,int len, int width, int height)
{
 int i,j,w,h, code, A,B,C,Z,AxorB;
 unsigned k;
 int x,y,x2,y2,n;
 unsigned char number;
 unsigned char *sour, *aux;
 unsigned char *Section[8];
 unsigned int Colour;

 w=width/16;
 if(w*16!=width)
  w++;
 h=height/16;
 if(h*16!=height)
  h++;
 sour=src;

#if DEBUG == 1
printf("Asigning section pointers\n");
#endif
 Section[0]=src+w*h;
 for(i=1;i<8;i++)
 {
  Section[i]=(unsigned char*)(*Section[0] << 24);
  Section[0]++;
  Section[i]+=(*Section[0] << 16);
  Section[0]++;
  Section[i]+=(*Section[0] << 8);
  Section[0]++;
  Section[i]+= *Section[0];
  Section[0]++;
 }/*if*/

#if DEBUG == 2
printf("Section[0]=");
for(i=0;i<10;i++)
 printf("%02x ",*(Section[0]+i));
printf("\n");
#endif


#if DEBUG == 2
printf("Sizes=\n");
  for(i=1;i<8;i++)
  {
   printf("Size[%i]=%i\n",i-1,Section[i]);
   Section[i]+=(unsigned)Section[i-1];
   for(j=0;j<10;j++)
    printf("%02x ",*(Section[i]+j));
   printf("\n");
  }/*for*/
#else
 for(i=1;i<8;i++)
  Section[i]+=(unsigned)Section[i-1];
#endif



#if DEBUG == 1
printf("Allocating sections array\n");
#endif

 /* Allocate Sections array */
 if((Sections=malloc(w*h*sizeof(int *))) == NULL)
 {
  perror("Error allocating memory for sections array\n");
  exit(1);
 }/*if*/
 for(i=0;i<w*h;i++)
  Sections[i]=NULL;

#if DEBUG == 1
printf("start the decompression\n");
#endif

 /*Start the decompression*/
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   code=*sour;
   sour++;
#if DEBUG == 3
 printf("code=%i\n", code);
#endif
   switch(code)
   {
    case 0x00:
     /* 256 Zeroes */
#if DEBUG == 2
  printf("256 Zeroes!\n");
#endif

     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=0;
      }/*for*/
     Sections[nsections++]=Past;

     break;
    case 0x01:
     /* 256 Colours equal to X */
#if DEBUG == 2
  printf("256 colours!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     Colour=(*Section[0]<<16);
     Section[0]++;
     Colour+=(*Section[0]<<8);
     Section[0]++;
     Colour+=*Section[0];
     Section[0]++;

     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=Colour;
      }/*for*/


     Sections[nsections++]=Past;

     break;
    case 0x02:
     /* 255 Colours equals and 1 more */
#if DEBUG == 2
  printf("255 colours!\n");
#endif

     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     Colour=(*Section[1]<<16);
     Section[1]++;
     Colour+=(*Section[1]<<8);
     Section[1]++;
     Colour+=*Section[1];
     Section[1]++;
     for(x=0;x<16;x++)
      for(y=0;y<16;y++)
      {
       Past[x + (y<<4)]=Colour;
      }/*for*/

     Colour=(*Section[1]<<16);
     Section[1]++;
     Colour+=(*Section[1]<<8);
     Section[1]++;
     Colour+=*Section[1];
     Section[1]++;
     x=*Section[1];
     y=x & 0xF;
     x=x>>4;
     Section[1]++;
     Past[x + (y<<4)]=Colour;


     Sections[nsections++]=Past;
     break;
    case 0x03:
     /* Section equal to a previous one*/
#if DEBUG == 2
  printf("Section founded!\n");
#endif

     x=(*Section[2]<<8);
     Section[2]++;
     x+=*Section[2];
     Section[2]++;
     x--;
#if DEBUG == 3
  printf("x=%i!\n",x);
#endif

     Sections[nsections++]=Sections[x];
     break;
    case 0x04:
     /* With colour elimination */
#if DEBUG == 2
  printf("With colour elimination!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     A=(*Section[3]<<16);
     Section[3]++;
     A+=(*Section[3]<<8);
     Section[3]++;
     A+=*Section[3];
     Section[3]++;
     B=(*Section[3]<<16);
     Section[3]++;
     B+=(*Section[3]<<8);
     Section[3]++;
     B+=*Section[3];
     Section[3]++;
     C=(*Section[3]<<16);
     Section[3]++;
     C+=(*Section[3]<<8);
     Section[3]++;
     C+=*Section[3];
     Section[3]++;
     aux=Section[3];
     Section[3]+=32;

     n=DireccionalInv(Section[3]);
     Section[3]+=n;

     AxorB=A^B;

     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       if(*aux & 0x80)
        Past[x + (y<<4)]^=AxorB;
       (*aux)<<=1;
       n++;
       if(n==8)
       {
        aux++;
        n=0;
       }/*if*/
      }/*for*/

     Z=A^B^C;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
       Past[x + (y<<4)]^=Z;



     Sections[nsections++]=Past;

     break;
    case 0x05:
     /* With Zero */
#if DEBUG == 2
  printf("With Zero!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/



     n=DireccionalInv(Section[4]);
     Section[4]+=n;


     Sections[nsections++]=Past;
     break;
    case 0x06:
     /* Without Zero */
#if DEBUG == 2
  printf("Without Zero!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     n=DireccionalInv(Section[5]);
     Section[5]+=n-4;



     Sections[nsections++]=Past;
     break;
    case 0x07:
     /* Raw Section */
#if DEBUG == 2
  printf("RAW Section!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/

     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       Past[x + (y<<4)]=*Section[6];
       Past[x + (y<<4)]<<=8;
       Section[6]++;
       Past[x + (y<<4)]+=*Section[6];
       Past[x + (y<<4)]<<=8;
       Section[6]++;
       Past[x + (y<<4)]+=*Section[6];
       Section[6]++;

      }/*for*/



     Sections[nsections++]=Past;
     break;
    case 0x08:
     /* 2 colours section*/
#if DEBUG == 2
  printf("2 colours!\n");
#endif
     if((Past=(int *)malloc(256*sizeof(int))) == NULL)
     {
      perror("Error allocating memory for one section\n");
      exit(1);
     }/*if*/
     A=(*Section[7]<<16);
     Section[7]++;
     A+=(*Section[7]<<8);
     Section[7]++;
     A+=*Section[7];
     Section[7]++;
     B=(*Section[7]<<16);
     Section[7]++;
     B+=(*Section[7]<<8);
     Section[7]++;
     B+=*Section[7];
     Section[7]++;

     n=0;
     for(y=0;y<16;y++)
      for(x=0;x<16;x++)
      {
       if(*Section[7] & 0x80)
        Past[x + (y<<4)]=A;
       else
        Past[x + (y<<4)]=B;
       (*Section[7])<<=1;
       n++;
       if(n==8)
       {
        Section[7]++;
        n=0;
       }/*if*/
      }/*for*/


     Sections[nsections++]=Past;
     break;
    default:
     printf("Error: unknown code!\n");
     break;
   }/*switch*/

#if DEBUG == 3
printf("One section decompressed (%i,%i)\n",j,i);
printf("Section:\n");
for(y=0;y<16;y++)
printf(" %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x %6x\n",
Past[0 + (y<<4)],
Past[1 + (y<<4)],
Past[2 + (y<<4)],
Past[3 + (y<<4)],
Past[4 + (y<<4)],
Past[5 + (y<<4)],
Past[6 + (y<<4)],
Past[7 + (y<<4)],
Past[8 + (y<<4)],
Past[9 + (y<<4)],
Past[10 + (y<<4)],
Past[11 + (y<<4)],
Past[12 + (y<<4)],
Past[13 + (y<<4)],
Past[14 + (y<<4)],
Past[15 + (y<<4)]
);

#endif

  }/*for*/

#if DEBUG == 1
printf("Drawing Sectinons\n");
#endif

 /* Paint the sections in the dst array*/
 k=0;
 for(i=0;i<h;i++)
  for(j=0;j<w;j++)
  {
   Past=Sections[k++];
   for(x=0;x<16;x++)
    for(y=0;y<16;y++)
    {
     if( ((j*16+x)<width) && ((i*16+y)<height) )
     {
      dst[(j*16+x)*3 + (i*16+y)*width*3]=(Past[x + (y<<4)]>>16) & 0xFF;
      dst[(j*16+x)*3 + (i*16+y)*width*3 + 1]=(Past[x + (y<<4)]>>8) & 0xFF;
      dst[(j*16+x)*3 + (i*16+y)*width*3 + 2]=Past[x + (y<<4)] & 0xFF;;

     }/*if*/
    }/*for*/
  }/*for*/


#if DEBUG == 1
printf("deallocating resources\n");
#endif

 /* Free the allocated resources */
 for(k=0;k<nsections;k++)
  if(Sections[k]!=NULL)
  {
   free(Sections[k]);
   for(j=k+1;j<nsections;j++)
    if(Sections[j]==Sections[k])
     Sections[j]=NULL;
   Sections[k]=NULL;
  }/*if*/

 free(Sections);
}/*Decompress*/

/*================================================================================*/
int main(int argc, char *argv[])
{
 int File=0;
 int Out=0;
 int i;
 unsigned char c;
 char Name[256];
 BitmapFileHeader BMFH;
 BitmapInfoHeader BMIH;
 char DIRHeader[]="DIR\0";
 unsigned char *src,*dst, *dst2;
 int len,len2;




 if(argc<2)
 {
  printf("USSAGE: bmp2dir <file>\n");
  exit(1);
 }/*if*/

 if((File=open(argv[1],O_RDONLY)) == -1)
 {
  printf("Error opening the file %s\n",argv[1]);
  perror("");
  exit(1);
 }/*if*/

 strcpy(Name,argv[1]);
 i=strlen(Name);
 while( (i>0) && (Name[i]!='.'))
  i--;

 if(Name[i]=='.')
 {
  i++;
  if(strcasecmp(Name+i,"bmp")==0)
  {
   /*Convert the bmp file to a dir file*/
   Name[i]='d';
   Name[i+1]='i';
   Name[i+2]='r';
   if((Out=creat(Name,(00400 | 00200))) == -1)
   {
    printf("Error opening the file %s\n",Name);
    perror("");
    exit(1);
   }/*if*/

   if(read(File,&BMFH,14)==-1)
   {
    perror("Error reading the File Header");
    exit(-1);
   }/*if*/

   if(BMFH.bfType!=0x4D42)
   {
    printf("This is not a BMP file!\n");
    exit(1);
   }/*if*/


   if(read(File,&BMIH,40)==-1)
   {
    perror("Error reading the Info Header");
    exit(-1);
   }/*if*/

   if(BMIH.biSize!=40)
   {
    printf("Sorry this program only manage windows bitmaps with 40 bytes of info header\n");
    exit(1);
   }/*if*/

   if(BMIH.biPlanes!=1)
   {
    printf("Sorry this program only manage windows bitmaps with 1 plane\n");
    exit(1);
   }/*if*/

   if(BMIH.biBitCount!=24)
   {
    printf("Sorry this program only manage windows bitmaps with 24 bits\n");
    exit(1);
   }/*if*/


   /* Write the dir header */
   if(write(Out,DIRHeader,4)==-1)
   {
    perror("Error writing to the output file\n");
    exit(1);
   }/*if*/

   if(write(Out,&BMIH.biWidth,4)==-1)
   {
    perror("Error writing to the output file\n");
    exit(1);
   }/*if*/

   if(write(Out,&BMIH.biHeight,4)==-1)
   {
    perror("Error writing to the output file\n");
    exit(1);
   }/*if*/

   if((src=malloc(BMIH.biWidth*BMIH.biHeight*3)) == NULL)
   {
    perror("Error allocating memory\n");
    exit(1);
   }/*if*/

   if((dst=malloc(BMIH.biWidth*BMIH.biHeight*3)) == NULL)
   {
    free(src);
    perror("Error allocating memory\n");
    exit(1);
   }/*if*/

   if((dst2=malloc(BMIH.biWidth*BMIH.biHeight*3)) == NULL)
   {
    free(src);
    perror("Error allocating memory\n");
    exit(1);
   }/*if*/


   if(read(File,src,BMIH.biWidth*BMIH.biHeight*3)==-1)
   {
    free(src);
    free(dst);
    perror("Error reading the Info Header");
    exit(-1);
   }/*if*/


   /* Call to the compression function */
   len=Compress(src,dst,BMIH.biWidth,BMIH.biHeight);

   /* Call to the compression function with filter*/
   sub_filter(src, dst2, BMIH.biWidth*BMIH.biHeight*3);
   memcpy(src,dst2,BMIH.biWidth*BMIH.biHeight*3);
   len2=Compress(src,dst2,BMIH.biWidth,BMIH.biHeight);

   if(len>len2)
   {
    free(dst);
    dst=dst2;
    dst2=NULL;
    len=len2;
    c=1; /* With filter */
    if(write(Out,&c,1)==-1)
    {
     perror("Error writing to the output file\n");
     exit(1);
    }/*if*/
   }/*if*/
   else
   {
    free(dst2);
    dst2=NULL;
    len2=0;
    c=0; /* Without filter */
    if(write(Out,&c,1)==-1)
    {
     perror("Error writing to the output file\n");
     exit(1);
    }/*if*/
   }/*else*/

   if(write(Out,dst,len)==-1)
   {
    free(src);
    free(dst);
    perror("Error writing to the output file\n");
    exit(1);
   }/*if*/


   free(src);
   free(dst);
   close(Out);
  }/*if*/
  else
  if(strcasecmp(Name+i,"dir")==0)
  {
   /*Convert the dir file to a bmp file*/
   Name[i]='b';
   Name[i+1]='m';
   Name[i+2]='p';
   if((Out=creat(Name,(00400 | 00200))) == -1)
   {
    printf("Error opening the file %s\n",Name);
    perror("");
    exit(1);
   }/*if*/

   if(read(File,DIRHeader,4)==-1)
   {
    perror("Error reading dir file header");
    exit(1);
   }/*if*/

   if(strcmp(DIRHeader,"DIR")!=0)
   {
    printf("This is not an DIR file!\n");
    exit(1);
   }/*if*/

   if(read(File,&BMIH.biWidth,4)==-1)
   {
    perror("Error reading the width");
    exit(1);
   }/*if*/

   if(read(File,&BMIH.biHeight,4)==-1)
   {
    perror("Error reading the height");
    exit(1);
   }/*if*/

   if(read(File,&c,1)==-1)
   {
    perror("Error reading the filter");
    exit(1);
   }/*if*/

   /*write the bitmap file header*/
   BMFH.bfType=0x4D42;
   BMFH.bfSize=54+BMIH.biWidth*BMIH.biHeight*3;
   BMFH.bfReserved1=0;
   BMFH.bfReserved2=0;
   BMFH.bfOffBits=54;

   if(write(Out,&BMFH.bfType,2)==-1)
   {
    perror("Error writing the bitmap file header");
    exit(1);
   }/*if*/
   if(write(Out,&BMFH.bfSize,12)==-1)
   {
    perror("Error writing the bitmap file header");
    exit(1);
   }/*if*/

   BMIH.biSize=40;
   BMIH.biPlanes=1;
   BMIH.biBitCount=24;
   BMIH.biCompresion=0;
   BMIH.biSizeImage=0;
   BMIH.biXPelsPerMeter=0;
   BMIH.biYPelsPerMeter=0;
   BMIH.biClrUsed=0;
   BMIH.biClrImportant=0;
   if(write(Out,&BMIH,40)==-1)
   {
    perror("Error writing the bitmap file header");
    exit(1);
   }/*if*/


   if((src=malloc(BMIH.biWidth*BMIH.biHeight*3)) == NULL)
   {
    perror("Error allocating memory\n");
    exit(1);
   }/*if*/

   if((dst=malloc(BMIH.biWidth*BMIH.biHeight*3)) == NULL)
   {
    free(src);
    perror("Error allocating memory\n");
    exit(1);
   }/*if*/

   if((len=read(File,src,BMIH.biWidth*BMIH.biHeight*3))==-1)
   {
    free(src);
    free(dst);
    perror("Error reading the Info Header");
    exit(-1);
   }/*if*/


   /* Call to the decompression function */
   Decompress(src,dst,len,BMIH.biWidth,BMIH.biHeight);

   if(c)
   {
    memcpy(src,dst,BMIH.biWidth*BMIH.biHeight*3);
    sub_filter_inv(src, dst, BMIH.biWidth*BMIH.biHeight*3);
   }/*if*/

   if(write(Out,dst,BMIH.biWidth*BMIH.biHeight*3)==-1)
   {
    free(src);
    free(dst);
    perror("Error writing to the output file\n");
    exit(1);
   }/*if*/


   free(src);
   free(dst);

   close(Out);
  }/*if*/


 }/*if*/
 else
 {
  printf("This file have not extension\n");
  exit(1);
 }/*else*/


 close(File);

 return 0;
}/*main*/
